/*
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU Affero General Public License as
** published by the Free Software Foundation, either version 3 of the
** License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU Affero General Public License for more details.
**
** You may find a copy of the GNU Affero GPL version 3 at the following
** location: https://www.gnu.org/licenses/agpl-3.0.en.html
** 
** Additional terms under GNU Affero GPL version 3 section 7:
** 
**   Under Section 7 of the GNU Affero GPL version 3, the following additional
**   terms apply to the works covered under the License.  These additional terms
**   are non-permissive additional terms allowed under Section 7 of the GNU
**   Affero GPL version 3 and may not be removed by you.
** 
**   0. Attribution Requirement.
** 
**     You must preserve all legal notices or author attributions in the covered
**     work or Appropriate Legal Notices displayed by works containing the covered
**     work.  You may not remove from the covered work any author or developer
**     credit already included within the covered work.
** 
**   1. No License To Use Trademarks.
** 
**     This license does not grant any license or rights to use the trademarks
**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
**     of Golden Code Development Corporation. You are not authorized to use the
**     name Golden Code, FWD, or the names of any author or contributor, for
**     publicity purposes without written authorization.
** 
**   2. No Misrepresentation of Affiliation.
** 
**     You may not represent yourself as Golden Code Development Corporation or FWD.
** 
**     You may not represent yourself for publicity purposes as associated with
**     Golden Code Development Corporation, FWD, or any author or contributor to
**     the covered work, without written authorization.
** 
**   3. No Misrepresentation of Source or Origin.
** 
**     You may not represent the covered work as solely your work.  All modified
**     versions of the covered work must be marked in a reasonable way to make it
**     clear that the modified work is not originating from Golden Code Development
**     Corporation or FWD.  All modified versions must contain the notices of
**     attribution required in this license.
*/
DEFINE TEMP-TABLE tt-latin1
   FIELD f1 AS INTEGER
   FIELD f2 AS CHARACTER CASE-SENSITIVE
   FIELD f3 AS CHARACTER
   INDEX pidx AS PRIMARY f2
   INDEX idx f1.


DEFINE VARIABLE i AS INTEGER.
DEFINE VARIABLE c1 AS CHARACTER CASE-SENSITIVE.
DEFINE VARIABLE c2 AS CHARACTER CASE-SENSITIVE.


DEFINE NEW SHARED STREAM s.
OUTPUT STREAM s TO VALUE("p4gl-locale.txt").

FUNCTION digit RETURNS CHARACTER (INPUT k AS INTEGER):
   RETURN IF k < 10 THEN STRING(k) ELSE CHR(k + 55).
END FUNCTION.


FUNCTION f RETURNS CHARACTER (INPUT k AS INTEGER) :
   DEFINE VARIABLE d1 AS INTEGER.
   DEFINE VARIABLE d2 AS INTEGER.

   d2 = k MOD 16.
   d1 = (k - d2) / 16.

   RETURN "<U00" + digit(d1) + digit(d2) + ">".
END FUNCTION.

DO i = 0 TO 255:
   CREATE tt-latin1.
   f1 = i.
   f2 = CHR(i) + CHR(160).
   f3 = CHR(i).
END.



DISPLAY STREAM s SKIP "toupper".
FOR EACH tt-latin1 USE-INDEX idx:
   c1 = f3.
   c2 = UPPER(c1).
   IF (c1 NE c2) THEN 
       DISPLAY STREAM s  "(" + f(f1) + "," + f(ASC(c2)) + ");" FORMAT "x(18)".
END.

DISPLAY STREAM s SKIP "tolower".
FOR EACH tt-latin1  USE-INDEX idx:
   c1 = f3.
   c2 = LOWER(c1).
   IF (c1 NE c2) THEN 
       DISPLAY STREAM s  "(" + f(f1) + "," + f(ASC(c2)) + ");" FORMAT "x(18)".
END.


DISPLAY STREAM s SKIP(2) "order_start forward".

FOR EACH tt-latin1:
   DISPLAY STREAM s f(f1) f3  + ' ' + UPPER(f3) + ' ' + LOWER(f3).
END.

/*
FOR EACH tt-latin1:
   DISPLAY f(f1) f3  + ' ' + UPPER(f3) + ' ' + LOWER(f3).
END.
*/

OUTPUT STREAM s CLOSE.

MESSAGE "OK".

