<?xml version="1.0"?>
<!-- 
/*
** Module   : misc.tpl
** Abstract : Miscellaneous schema-related AST templates
**
** Copyright (c) 2005-2017, Golden Code Development Corporation.
**
** _#_ _I_ __Date__ _T_ __JPRM__ ________________Description_________________
** 001 ECF 20050930 ADD   @22948 Good working version. Provides templates for
**                               miscellaneous schema-related AST building
**                               tasks. This initial version contains XML AST
**                               templates used to create the XML data field
**                               length statistics for character and raw
**                               fields.
** 002 ECF 20060331 CHG   @25328 Added 'p2o_default_init' template. Used to
**                               add an 'initial' element to a DMO class
**                               property.
*/
-->
<!--
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU Affero General Public License as
** published by the Free Software Foundation, either version 3 of the
** License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU Affero General Public License for more details.
**
** You may find a copy of the GNU Affero GPL version 3 at the following
** location: https://www.gnu.org/licenses/agpl-3.0.en.html
** 
** Additional terms under GNU Affero GPL version 3 section 7:
** 
**   Under Section 7 of the GNU Affero GPL version 3, the following additional
**   terms apply to the works covered under the License.  These additional terms
**   are non-permissive additional terms allowed under Section 7 of the GNU
**   Affero GPL version 3 and may not be removed by you.
** 
**   0. Attribution Requirement.
** 
**     You must preserve all legal notices or author attributions in the covered
**     work or Appropriate Legal Notices displayed by works containing the covered
**     work.  You may not remove from the covered work any author or developer
**     credit already included within the covered work.
** 
**   1. No License To Use Trademarks.
** 
**     This license does not grant any license or rights to use the trademarks
**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
**     of Golden Code Development Corporation. You are not authorized to use the
**     name Golden Code, FWD, or the names of any author or contributor, for
**     publicity purposes without written authorization.
** 
**   2. No Misrepresentation of Affiliation.
** 
**     You may not represent yourself as Golden Code Development Corporation or FWD.
** 
**     You may not represent yourself for publicity purposes as associated with
**     Golden Code Development Corporation, FWD, or any author or contributor to
**     the covered work, without written authorization.
** 
**   3. No Misrepresentation of Source or Origin.
** 
**     You may not represent the covered work as solely your work.  All modified
**     versions of the covered work must be marked in a reasonable way to make it
**     clear that the modified work is not originating from Golden Code Development
**     Corporation or FWD.  All modified versions must contain the notices of
**     attribution required in this license.
-->

<templates>

  <!-- statistics root element -->
  <ast-root name="statistics_elem" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="statistics">
      <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- distribution element -->
  <ast-root name="distribution_elem" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="distribution">
      <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="type">
          <ast id="0" type="CONTENT" text="${type}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="class">
          <ast id="0" type="CONTENT" text="${class}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- distribution bucket element -->
  <ast-root name="bucket_elem" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="bucket">
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="value">
          <ast id="0" type="CONTENT" text="${value}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="count">
          <ast id="0" type="CONTENT" text="${count}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- default initializer for a DMO field -->
  <ast-root name="p2o_default_init" terse="true" ast_class="com.goldencode.p2j.schema.DataModelAst" >
    <ast id="0" type="INITIAL" text="initial">
      <ast id="0" type="${type}" text="${text}" />
    </ast>
  </ast-root>
  
</templates>