/*
** Module   : p2j.clipboard_helpers.js
** Abstract : GUI-specific text clipboard processing
**
** Copyright (c) 2014-2017, Golden Code Development Corporation.
**
** -#- -I- --Date-- ------------------------------Description----------------------------------
** 001 GES 20150324 First version, with refactored content moved from tty.clipboard.js.
** 002 SBI 20150731 Applied "use strict" directive, fixed undeclared variables
**                  and corrected the selection rectangle coordinates.
** 003 GES 20150710 Eliminated the ChUI implementation and implemented a first pass of GUI
**                  support.  It is not yet fully operational.
** 004 SBI 20150822 Fix for typo.
** 005 SBI 20160316 Match function name change.
** 006 SBI 20160523 Fixed copy/cut/paste work flow.
*/
/*
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU Affero General Public License as
** published by the Free Software Foundation, either version 3 of the
** License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU Affero General Public License for more details.
**
** You may find a copy of the GNU Affero GPL version 3 at the following
** location: https://www.gnu.org/licenses/agpl-3.0.en.html
** 
** Additional terms under GNU Affero GPL version 3 section 7:
** 
**   Under Section 7 of the GNU Affero GPL version 3, the following additional
**   terms apply to the works covered under the License.  These additional terms
**   are non-permissive additional terms allowed under Section 7 of the GNU
**   Affero GPL version 3 and may not be removed by you.
** 
**   0. Attribution Requirement.
** 
**     You must preserve all legal notices or author attributions in the covered
**     work or Appropriate Legal Notices displayed by works containing the covered
**     work.  You may not remove from the covered work any author or developer
**     credit already included within the covered work.
** 
**   1. No License To Use Trademarks.
** 
**     This license does not grant any license or rights to use the trademarks
**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
**     of Golden Code Development Corporation. You are not authorized to use the
**     name Golden Code, FWD, or the names of any author or contributor, for
**     publicity purposes without written authorization.
** 
**   2. No Misrepresentation of Affiliation.
** 
**     You may not represent yourself as Golden Code Development Corporation or FWD.
** 
**     You may not represent yourself for publicity purposes as associated with
**     Golden Code Development Corporation, FWD, or any author or contributor to
**     the covered work, without written authorization.
** 
**   3. No Misrepresentation of Source or Origin.
** 
**     You may not represent the covered work as solely your work.  All modified
**     versions of the covered work must be marked in a reasonable way to make it
**     clear that the modified work is not originating from Golden Code Development
**     Corporation or FWD.  All modified versions must contain the notices of
**     attribution required in this license.
*/

"use strict";

p2j.clipboard_helpers = (function() 
{
   /** Clipboard helper object which will be returned from this initialization function. */
   var me = {};
   
   /**
    * Init module.
    * 
    * @param {type} cfg configurartion object
    */
   me.init = function(cfg)
   {
   };
   
   /**
    * Return the currently selected text.
    * 
    * @return   The text that is selected.
    */
   me.getSelectedText = function()
   {
      return p2j.clipboard.getSelection();
   };
   
   /**
    * Check if this client needs an active selection area for copy to work.
    * 
    * @returns   {boolean} Always returns false.
    */
   me.needsSelection = function()
   {
      return false;
   };
   
   /**
    * Clear selection on screen.
    * 
    * @returns {undefined}
    */
   me.clearSelection = function()
   {
   };
   
   /**
    * Check if there is an active selection area.
    * 
    * @returns   {boolean} true if have a selection false if not.
    */
   me.haveSelection = function()
   {
      return false;
   };
   
   return me;   
}());